# -*- coding: utf-8 -*-
import os
import time
import oss2
import json

from resource import bagtocsv_rebot

import logging

path1 = '/mnt/disk001/dcl_data_process/src/python2/pjibot/'
path2 = '/mnt/disk001/run' # 生成评价报告pdf的可执行文件路径
path3 = '/mnt/disk001/dcl_data_process/src/python3/pjibot_indoor'
path4 = '/mnt/disk001/dcl_data_process/src/python3/pjibot_indoor/filter_pos.py'
pgm_path = '/mnt/disk001/dcl_data_process/src/python3/pjibot_indoor/resource/shiyanshi_newpgm_20240416.pgm'

logging.basicConfig(filename=path1 + 'log/csv-pjibot_guide.log', level=logging.INFO,
                    format='%(asctime)s - %(levelname)s - %(message)s')

key1 = 'pjibot/'
sleep_time = 30  # 每多少秒扫描一次
error_bag_json = "/mnt/disk001/dcl_data_process/src/python2/pjibot/csv-errorBag.json"
def parse_json_to_string_array(file_path):
    try:
        # 打开并读取JSON文件（Python 2中不支持encoding参数，需要使用codecs模块或处理文件读取后的编码）
        with open(file_path, 'r') as file:
            # 读取文件内容
            file_content = file.read()
            # 解析JSON内容（Python 2中json.loads用于解析字符串）
            data = json.loads(file_content.decode('utf-8'))  # 假设文件是UTF-8编码，这里需要手动解码

        # 检查数据是否是一个列表，并且列表中的元素是否是字符串
        if isinstance(data, list):
            for item in data:
                if not isinstance(item, basestring):  # Python 2中字符串类型包括str和unicode，用basestring检查
                    raise ValueError("JSON数组中的元素不是字符串")
            return data
        else:
            return []
    except Exception as e:
        return []
def list_to_json_file(data, file_path):
    """
    将列表转换为JSON格式并写入指定的文件路径。
    如果文件已存在，则覆盖它。

    参数:
    data (list): 要转换为JSON的列表。
    file_path (str): 要写入JSON数据的文件路径。
    """
    # 将列表转换为JSON格式的字符串，并确保输出为UTF-8编码的字符串
    json_data = json.dumps(data, ensure_ascii=False, indent=4)
    json_data_utf8 = json_data.encode('utf-8')  # 编码为UTF-8

    # 以写入模式打开文件，如果文件已存在则覆盖
    with open(file_path, 'w') as file:
        # 将UTF-8编码的JSON字符串写入文件
        file.write(json_data_utf8)

def parse_csv(costmap_bag, data_bag, parse_prefix, local_parse_dir, local_delete_list):
    try:
        bagtocsv_rebot.parse(costmap_bag, data_bag, local_parse_dir + '/csv/')
        bagname = data_bag.split('/')[-1].split('.')[0]
        local_csv_dir = os.path.join(local_parse_dir + '/csv/', bagname)
        csv_file_name1 = 'pos_pji'
        local_csv_file_path1 = str(local_csv_dir) + '/' + str(csv_file_name1) + '.csv'
        local_delete_list.append(local_csv_file_path1)
        oss_csv_object_key1 = parse_prefix + csv_file_name1 + '.csv'
        bucket.put_object_from_file(oss_csv_object_key1, local_csv_file_path1)

        csv_file_name2 = 'EgoState_pji'
        local_csv_file_path2 = str(local_csv_dir) + '/' + str(csv_file_name2) + '.csv'
        local_delete_list.append(local_csv_file_path2)
        oss_csv_object_key2 = parse_prefix + csv_file_name2 + '.csv'
        bucket.put_object_from_file(oss_csv_object_key2, local_csv_file_path2)

        # 下载 track.png
        track_png_key = parse_prefix + 'track.png'
        bucket.get_object_to_file(track_png_key, str(local_csv_dir) + '/track1.png')
        # 生成pdf 报告
        os.chdir(path2)
        command1 = './pji_single ' + str(local_csv_dir) + '/ ' + str(local_csv_dir) + '/ ' + str(
            local_csv_dir) + '/track1.png ' + data_bag.split('/')[-1].split('.')[0]
        logging.info("调用生成pdf 报告命令: %s" % str(command1))
        os.system(command1)
        bucket.put_object_from_file(parse_prefix + 'report.pdf',
                                    str(local_csv_dir) + '/report.pdf')
        local_delete_list.append(str(local_csv_dir) + '/report.pdf')

        # ---------------------------------------------------
        csv_file_name3 = 'merged_obstacles'
        local_csv_file_path3 = str(local_csv_dir) + '/' + str(csv_file_name3) + '.csv'
        oss_csv_object_key3 = parse_prefix + csv_file_name3 + '.csv'
        bucket.put_object_from_file(oss_csv_object_key3, local_csv_file_path3)

        # 根据 merged_obstacles 和 机器人指定的pgm文件 生成新的 merged_obstacles 文件
        os.chdir(path3)
        command2 = 'python3 ' + path4 + ' ' + pgm_path + ' ' + local_csv_file_path3
        logging.info("调用命令 merged_obstacles_new.csv 生成命令: %s" % str(command2))
        os.system(command2)
        time.sleep(2)
        bucket.put_object_from_file(oss_csv_object_key3.replace('merged_obstacles', 'merged_obstacles_new'),
                                    local_csv_file_path3)  # 因为生成的文件是同名覆盖的
        # todo 暂时不删除 排查问题
        local_delete_list.append(local_csv_file_path3)

        # 这里不要删除了，不然无法复现pdf
        # bucket.delete_object(track_png_key)
    except Exception as e2:
        error_bag_list = parse_json_to_string_array(error_bag_json)
        error_bag_list.append(parse_prefix)
        list_to_json_file(error_bag_list, error_bag_json)
        # 当出现异常时执行的代码
        logging.exception("生成csv报错: %s", e2)


# ------- 获取合并之后的bag包，解析出csv -------
if __name__ == '__main__':
    # 1 创建阿里云对象
    auth = oss2.Auth('n8glvFGS25MrLY7j', 'xZ2Fozoarpfw0z28FUhtg8cu0yDc5d')
    endpoint = 'oss-cn-beijing-gqzl-d01-a.ops.gqzl-cloud.com'
    bucket = oss2.Bucket(auth, endpoint, 'pji-bucket1')
    while True:
        logging.info("开始新一轮扫描")
        time.sleep(sleep_time)
        try:
            local_delete_list = []
            oss_delete_list = []
            prefix_list = []
            # 2 获取已经上传完成的所有目录并分组
            for obj1 in oss2.ObjectIterator(bucket, prefix=key1):
                # 获取合并后的包
                merged_bag_object_key = str(obj1.key)
                if 'data_merge' in str(obj1.key) and str(obj1.key).endswith('.bag'):
                    merged_bag_object_key_split = merged_bag_object_key.split('/')
                    merged_prefix = '/'.join(merged_bag_object_key_split[:-1])
                    parse_prefix = merged_prefix.replace('data_merge', 'data_parse')
                    parse_prefix_full = merged_bag_object_key.replace('data_merge', 'data_parse')[:-4] + '/'
                    csv1_done = False
                    csv2_done = False
                    csv3_done = False
                    for obj2 in oss2.ObjectIterator(bucket, prefix=parse_prefix_full):
                        if '/pos_pji.csv' in str(obj2.key):
                            csv1_done = True
                        if '/EgoState_pji.csv' in str(obj2.key):
                            csv2_done = True
                        if '/merged_obstacles.csv' in str(obj2.key):
                            csv3_done = True
                    if csv1_done and csv2_done and csv3_done:
                        continue
                    error_bag_list = parse_json_to_string_array(error_bag_json)
                    if parse_prefix_full in error_bag_list:
                        continue
                    logging.info("开始生成场景还原csv: %s" % str(obj1.key))
                    local_merged_bag_path = path1 + 'camera/' + merged_bag_object_key
                    local_merged_dir = '/'.join(local_merged_bag_path.split('/')[:-1])
                    local_parse_dir = local_merged_dir.replace('data_merge', 'data_parse')
                    if not os.path.exists(local_merged_dir):
                        os.makedirs(local_merged_dir)
                    if not os.path.exists(local_parse_dir):
                        os.makedirs(local_parse_dir)
                    merged_bag_full_name = merged_bag_object_key_split[-1]
                    merged_bag_name = merged_bag_full_name.split('.')[0]
                    try:
                        bucket.get_object_to_file(merged_bag_object_key, local_merged_bag_path)
                    except Exception as e:
                        logging.exception("下载合并后的bag包失败: %s" % str(e))

                    local_delete_list.append(local_merged_bag_path)
                    # 下载costmap.bag
                    costmap_key = merged_prefix.replace('data_merge', '') + 'costmap.bag'
                    logging.info("costmap.bag包的key为: %s" % str(costmap_key))
                    bucket.get_object_to_file(costmap_key, local_merged_dir + 'costmap.bag')
                    # 2 生成 pos_orig.csv 和 pos_hmi.csv
                    parse_csv(local_merged_dir + 'costmap.bag', local_merged_bag_path, parse_prefix_full,
                              local_parse_dir, local_delete_list)

            # 删除本地临时文件
            if len(local_delete_list) > 0:
                for local_delete in local_delete_list:
                    try:
                        os.remove(local_delete)
                    except Exception as e:
                        logging.exception("捕获到一个异常: %s" % str(e))
        except Exception as e:
            logging.exception("全局错误处理: %s" % str(e))
